import { createApp } from 'vue'
import { createAxios, createHttp, icpxTransform, icpxTransformConfig } from '@crami/http'
import App from './App.vue'
import '@unocss/reset/tailwind.css'
import 'uno.css'

const axios = createAxios({
  baseURL: '/',
})

axios.interceptors.request.use((config) => {
  return config
})

axios.interceptors.response.use((response) => {
  return response.data
})

// axios.interceptors.request = function() {
//
// }
const http = createHttp(axios, {
  responseTransform: icpxTransform,
  requestTransform: icpxTransformConfig,
  headers: () => ({
    token: 'this is my token',
  }),
})

const app = createApp(App)

app.use(http)

app.mount('#app')
