import type { AxiosInstance } from 'axios'
import type { App, Plugin } from 'vue'
import { merge } from 'lodash'
import type { CramiHttpOptions } from './typing'
import initOptions from './init-options'
import type { InitHttpCallback } from './init-http'
import initHttp from './init-http'
import { Http } from './constant'

export const createHttp = (instance: AxiosInstance, options?: CramiHttpOptions): Plugin &{ version: string } => {
  // 初始化配置
  initOptions(instance, options)
  // 创建axios实例
  const InitHttp = initHttp(instance) as InitHttpCallback
  // 合并实例
  (Http as any).__isMerging = true
  merge(Http as any, InitHttp);
  (Http as any).__isMerging = false
  delete (Http as any).__isMerging
  // 返回需要实例化的对象的信息
  return {
    version: '2.0.0',
    install: (app: App) => {
      app.config.globalProperties.$http = Http
    },
  }
}
